//+--------------------------------------------------------------------------------+
//|  RSIOMA_v4  (MTF-std)   by   Mladen        Kalenzo      2007 | ForexTSD.com |ik|
//|  fxbs & Hornet ( 2007, ForexTSD.com)       MetaQuotes Software Corp.           |
//|  Hist & Levels 20/80;30/70 CrossSig        web: http://www.fxservice.eu        |
//|  Rsioma/MaRsioma X sig; ()                 email: bartlomiej.gorski@gmail.com  |
//+--------------------------------------------------------------------------------+
#property copyright "mladen. public domain. ForexTSD.com"
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/ Kalenzo|bartlomiej.gorski@gmail.com "

//#define set_global

#ifdef  set_global
  #include <global_var.mqh>
#endif 

#property indicator_separate_window
#property indicator_buffers   19
#property indicator_minimum -20
#property indicator_maximum 120
#property indicator_color1     DodgerBlue
#property indicator_color2     Red
#property indicator_color3     Lime
#property indicator_color4     Magenta
#property indicator_color5     DodgerBlue
#property indicator_color6     Yellow//BlueViolet
#property indicator_color7     Lime//Aqua       
#property indicator_color8     Red//DeepPink   
#property indicator_color9 clrLime
#property indicator_color10 clrGray
#property indicator_color11 clrRed
#property indicator_color12 clrMaroon
#property indicator_color13 clrDarkGreen
//
#property indicator_width1  2   
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width7  2//1
#property indicator_width8  2//1
//
//------------------------------------------

//---- input parameters


extern int Last_Bars = 6300; //500 za mao !!! Dla M5 3000 conajmniej
extern string Timeframe       ="0"; //Current TF = 0
extern string TimeFrames_Periods  = "M1;M5;M15;M30;H1;H4;D1;W1;MN";
extern int    RSIOMA          = 14;//8
extern int    RSIOMA_MODE     = MODE_EMA;
extern int    RSIOMA_PRICE    = PRICE_CLOSE;
extern int    Ma_RSIOMA       = 34;//21
extern int    Ma_RSIOMA_MODE  = MODE_EMA;

extern double BuyTrigger          = 10.00;//20
extern double SellTrigger         = 90.00;//80
extern color  BuyTriggerColor     = Magenta;
extern color  SellTriggerColor    = DodgerBlue;

extern double MainTrendLong       = 70.00;
extern double MainTrendShort      = 30.00;
extern color  MainTrendLongColor  = LimeGreen;//Green
extern color  MainTrendShortColor = Red;
extern double MajorTrend          = 50;
extern color  marsiomaXupSigColor = Aqua;      //DeepSkyBlue
extern color  marsiomaXdnSigColor = DeepPink;  //Crimson

//extern int    Last_Bars         = 6000;

extern string note_Choose_TimeFrames  =   "TF as in MT4 Periodicity bar:";
extern string as_Periods          = "(M1;M5;M15;M30;H1;H4;D1;W1;MN; or:)";
extern string or_Minutes          = "(1,5,15,30,60,240,1440,10080,43200)";
extern string CurrentTF_0         = "Current TF = 0 (Zero)";

extern double ZeroLevel = 5;
extern bool ShowDYLabel = true; //show TimeFrame label
extern int DYLabelX = 220;
extern int DYLabelY = 10;
extern int DYLabelSize = 10;
extern color DYLabelColor = clrYellow;
extern color LevelColor	= clrDarkSlateGray;
extern double Level1 = 20;
extern double Level2 = 50;
extern double Level3 = 80;
extern bool RectsBelow = false;
extern bool ShowTrendLines = true;
extern bool RectsTrendLines = false;
extern string GlobalVarSuffix = "";

extern int MinRefreshSec = 1;//10;
datetime LastTime = 0;
int RectSize = 14; //Wingdings rect
//---- buffers
double         Buf1UpHigh[];
double         Buf1UpLow[];
double         Buf1Zero[];
double         Buf1DnHigh[];
double         Buf1DnLow[],
Buffer20[],
				Buffer50[],
				Buffer80[];

string GlobalRSIOMASlope = "RSIOMAValue",
GlobalRSIOMATrend = "RSIOMATrend",
LblRsioma = "LblRSIOMA",
LblDY, LblDYRect;
double LastdY = 0;
datetime LastRefreshT;			
//---- buffers
//
//
//    "indexes"
//

double MABuffer1[];
double RSIBuffer1[];
double marsioma1[];

//
//
//    indexes  (real)
//
//

double RSIBuffer[];
double bdn[];
double bup[];
double sdn[];
double sup[];
double marsioma[];
double marsiomaXupSig[];
double marsiomaXdnSig[];

//
//
//
//
//

int      correction;
datetime lastBarTime;
string   short_name;

//
//
//
//
//

int      TimeFrame;
datetime TimeArray[];
bool     DiferentTimeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int deinit(){
  ObjectDelete(0, LblDY);
  ObjectDelete(0, LblDYRect);
#ifdef set_global
  DelGlobalVar(GlobalRSIOMASlope + "_0");
  DelGlobalVar(GlobalRSIOMASlope + "_1");
  DelGlobalVar(GlobalRSIOMASlope + "_2");
#endif 
  return 0;  
}


int Chart_Scale = 0;

int ChartScaleGet()
  {
  long result = -1;
  ChartGetInteger(0,CHART_SCALE,0,result);
  return((int)result);
  }
  
void OnChartEvent(const int id, const long &lparam, const double &dparam, const string &sparam){
  if (id == CHARTEVENT_CHART_CHANGE){
    int Scale = ChartScaleGet();
    if (Scale != Chart_Scale)
      InitWidth();
  }/**/
}

void InitWidth(){
 Chart_Scale = ChartScaleGet();
  
  //Set bar widths      
  int Bar_Width;       
  if(Chart_Scale == 0) {Bar_Width = 1;}
  else {if(Chart_Scale == 1) {Bar_Width = 1;}      
  else {if(Chart_Scale == 2) {Bar_Width = 3;}
  else {if(Chart_Scale == 3) {Bar_Width = 2;}
  else {if(Chart_Scale == 4) {Bar_Width = 4;}
  else {Bar_Width = 5;} }}}}
  
/*  
  if (Chart_Scale <= 2){
  // Bar_Width = Bar_Width + 2;//3; 
   for (int i=0; i < indicator_buffers; i++){
     SetIndexArrow(i, 158);//115);//158);
   }
  }
  else
  for (i=0; i < indicator_buffers; i++){
    SetIndexArrow(i, 167);
  }/**/
  //na razie
  /*Bar_Width = Bar_Width + 2;
  string S = "AngReader " + Chart_Scale;//Bar_Width;  
  IndicatorShortName(S);/**/
  if (Chart_Scale <= 2)
  for (int i = 8; i <= 12; i++){
    SetIndexStyle(i, DRAW_ARROW, EMPTY, Bar_Width);//, 0, Bar_Width, indicator_color4);    
    SetIndexArrow(i, 158);//250);//167);
  }  
  else 
  for (i = 8; i <= 12; i++){
    SetIndexStyle(i, DRAW_ARROW, EMPTY, Bar_Width);//, 0, Bar_Width, indicator_color4);    
    SetIndexArrow(i, 167);//250);//167);
  }  
}

int init()
{  isNewBarT0 = 0; 
   FIsNewBar = true;
   LastdY = 0;
   
   //
   //
   //
   //
   //
    if (Last_Bars >= Bars - 30)
     Last_Bars = Bars - 30;     
   LastRefreshT = 0;
   SetIndexBuffer(0,RSIBuffer);
   SetIndexBuffer(2,bup);
   SetIndexBuffer(1,bdn);
   SetIndexBuffer(3,sdn);  //Magneta
   SetIndexBuffer(4,sup);  //DodgerBlue
   SetIndexBuffer(5,marsioma);
   SetIndexBuffer(6,marsiomaXupSig);
   SetIndexBuffer(7,marsiomaXdnSig);

      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
      SetIndexStyle(4,DRAW_NONE);
      SetIndexStyle(5,DRAW_NONE);
    if (ShowTrendLines){  
      SetIndexStyle(6,DRAW_HISTOGRAM);
      SetIndexStyle(7,DRAW_HISTOGRAM);
    }
    else{  
      SetIndexStyle(6,DRAW_NONE);
      SetIndexStyle(7,DRAW_NONE);
    }
  
   SetIndexLabel(0,"Rsioma ["+Timeframe+"]("+RSIOMA+")");
   SetIndexLabel(5,"MaRsioma ["+Timeframe+"]("+Ma_RSIOMA+")");
   SetIndexLabel(1,"TrendDn ["+Timeframe+"]("+RSIOMA+")");
   SetIndexLabel(2,"TrendUp ["+Timeframe+"]("+RSIOMA+")");
     SetIndexLabel(3, "DnXLevel ["+Timeframe+"]("+RSIOMA+")");//Magneta
     SetIndexLabel(4, "UpXLevel ["+Timeframe+"]("+RSIOMA+")");//DodgerBlue

   SetIndexLabel(6,"Rs/MaRs UpXsig ["+Timeframe+"]("+RSIOMA+")");
   SetIndexLabel(7,"Rs/MaRs DnXsig ["+Timeframe+"]("+RSIOMA+")");
 
  SetIndexBuffer(8, Buf1UpHigh);
   SetIndexBuffer(9, Buf1Zero);
   SetIndexBuffer(10, Buf1DnHigh);
   SetIndexBuffer(11, Buf1DnLow);
   SetIndexBuffer(12, Buf1UpLow);
   
   SetIndexBuffer(13, Buffer20);
  SetIndexBuffer(14, Buffer50);
  SetIndexBuffer(15, Buffer80);
  SetIndexStyle(13, DRAW_LINE, STYLE_DOT, 1, LevelColor);
  SetIndexStyle(14, DRAW_LINE, STYLE_DOT, 1, LevelColor);
  SetIndexStyle(15, DRAW_LINE, STYLE_DOT, 1, LevelColor);
    InitWidth();
/*    
   int Bar_Width = 2;
   for (int i = 8; i <= 12; i++){
    //SetIndexLabel(i, NULL);
    //SetIndexStyle(i, DRAW_HISTOGRAM, 0, Bar_Width);//, 0, Bar_Width, indicator_color4);    
    SetIndexStyle(i, DRAW_ARROW, EMPTY, Bar_Width);//, 0, Bar_Width, indicator_color4);    
    SetIndexArrow(i, 167);//250);//167);
   }/**/
   for (int i = 8; i < indicator_buffers; i++)
    SetIndexLabel(i, NULL);
   IndicatorDigits(0); 
   //
   //
   //    additional buffer(s)
   //
   //


      TimeFrame         = stringToTimeFrame(Timeframe);
      DiferentTimeFrame = (TimeFrame!=Period());
      correction        = RSIOMA+RSIOMA+Ma_RSIOMA;
      Last_Bars       = MathMin(Bars,MathMax(Last_Bars,300));
   SetIndexBuffer(16, MABuffer1);   
   SetIndexStyle(16, DRAW_NONE);
   SetIndexBuffer(17, RSIBuffer1);
   SetIndexStyle(17, DRAW_NONE);
   SetIndexBuffer(18, marsioma1);
   SetIndexStyle(18, DRAW_NONE);
/*
          ArrayResize( MABuffer1 ,Last_Bars+correction);
          ArrayResize( RSIBuffer1,Last_Bars+correction);
          ArrayResize( marsioma1 ,Last_Bars+correction);
          ArraySetAsSeries(MABuffer1 ,true);
          ArraySetAsSeries(RSIBuffer1,true);
          ArraySetAsSeries(marsioma1 ,true);
/**/          
                 lastBarTime = EMPTY_VALUE;

      //
      //
      //
      //
      //

   short_name = StringConcatenate("RSIOMA[",TimeFrameToString(TimeFrame),"](",RSIOMA,")(",Ma_RSIOMA,")");   
   IndicatorShortName(short_name);
    int window =  ChartWindowFind();//WindowFind(Indicator_Name);
    
   if (ShowDYLabel){ 
     string ID = LblRsioma + window + GlobalVarSuffix;//Indicator_Name + Objs;  
     LblDY = ID;
     LblDYRect = LblDY + "Rect";
      //Objs++;
    (ObjectCreate(ID, OBJ_LABEL, window, 0, 0));
      {       
      //double GUIScale = GetGlobalVar("GUIScale");             
      ObjectSet(ID,     OBJPROP_CORNER,   1);
      //ObjectSet(ID,     OBJPROP_XDISTANCE, DYLabelX);
      //ObjectSet(ID,     OBJPROP_YDISTANCE, DYLabelY);
      ObjectSetText(ID,  "?", DYLabelSize, "Arial", DYLabelColor);/**/     
      ObjectSetString(0, ID, OBJPROP_TOOLTIP, "RSIOMA");   
      /*ObjectSetInteger(0 ,ID, OBJPROP_ZORDER, 20);  
      ObjectSetInteger(0,ID,OBJPROP_BACK,false);/**/
      }
      ID = LblDYRect;
      //Objs++;
      (ObjectCreate(ID, OBJ_LABEL, window, 0, 0));
        {                    
        ObjectSet(ID,     OBJPROP_CORNER,   1);
        //ObjectSet(ID,     OBJPROP_XDISTANCE, DYLabelX - GetX(20, GUIScale));
        //ObjectSet(ID,     OBJPROP_YDISTANCE, DYLabelY - GetX(3, GUIScale));
        ObjectSetText(ID,  CharToStr(110), RectSize, "Wingdings", clrGray);/**/     
        ObjectSetString(0, ID, OBJPROP_TOOLTIP, "Up / Down");   
        /*ObjectSetInteger(0 ,ID, OBJPROP_ZORDER, 20);  
        ObjectSetInteger(0,ID,OBJPROP_BACK,false);/**/
        }  
     SetLabelPos();
   }   
   for (i = 0; i <= indicator_buffers - 1; i++)    
     SetIndexDrawBegin(i, 30);      
   return(0);
}

void SetLabelPos(bool FirstTime = true){
  static datetime LabelPosT = 0;
  if (ShowDYLabel){
    if (FirstTime || (!FirstTime && TimeCurrent() - LabelPosT > 60)){
      LabelPosT = TimeCurrent();
      
    	ObjectSet(LblDY,     OBJPROP_XDISTANCE, DYLabelX);
    	ObjectSet(LblDY,     OBJPROP_YDISTANCE, DYLabelY);
    	ObjectSet(LblDYRect,     OBJPROP_XDISTANCE, DYLabelX - (20));
    	ObjectSet(LblDYRect,     OBJPROP_YDISTANCE, DYLabelY - (3));
  	}
  }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{  datetime CurrentTime = TimeLocal();
   if (CurrentTime - LastTime < MinRefreshSec) 
     return (-1);
   LastTime = CurrentTime;
   
   static bool Initialized=false;
   int    counted_bars=IndicatorCounted();
   int    limit,i,y;

   //
   //
   //
   //
   //

   if(!Initialized) {
       Initialized=true;
         drawLine(BuyTrigger,"BuyTrigger", BuyTriggerColor);
         drawLine(SellTrigger,"SellTrigger", SellTriggerColor );
         drawLine(MainTrendLong,"MainTrendLong", MainTrendLongColor );
         drawLine(MainTrendShort,"MainTrendShort",MainTrendShortColor );
      }         
      
   //
   //
   //
   //
   //
               
   if(counted_bars<0) return(-1);
   FIsNewBar = isNewBar();  
    
   if(lastBarTime != Time[0]) {
      lastBarTime  = Time[0];
      if (TimeCurrent() - LastRefreshT > 300){ //refresh all @ 5 mins
        LastRefreshT = TimeCurrent();
        counted_bars = 0;
      }     
   }         
    if(counted_bars>0) counted_bars--;
    limit=Bars-counted_bars;
    if (limit >Last_Bars)
      limit = Last_Bars;
    
    limit=MathMin(MathMax(TimeFrame/Period(),limit),Last_Bars+correction);
    
    ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,TimeFrame);
   
   //
   //
   //
   //
   //
   

      for(i=limit;i>=0;i--) MABuffer1[i]  = iMA(Symbol(),TimeFrame,RSIOMA,0,RSIOMA_MODE,RSIOMA_PRICE,i);
      for(i=limit;i>=0;i--) RSIBuffer1[i] = iRSIOnArray(MABuffer1,0,RSIOMA,i);
      for(i=limit;i>=0;i--) marsioma1[i]  = iMAOnArray(RSIBuffer1,0,Ma_RSIOMA,0,Ma_RSIOMA_MODE,i); 
      
      //
      //
      //
      //
      //

      for(i=0,y=0;i<limit;i++)
      {
         if  (DiferentTimeFrame) { if(Time[i]<TimeArray[y]) y++; }
         else y = i;

            RSIBuffer[i] = RSIBuffer1[y];
            marsioma[i]  = marsioma1[y];
      }

      //
      //
      //
      //
      //
      bool TrendUp = false;
      bool TrendDn = false;
      
      if (limit < 10){ //find trend start/stop
        for (i = limit; i < MathMin(Bars - 30, limit + 100); i++){
           if(/*RSIBuffer[i+1]<=marsioma[i+1]&&/**/RSIBuffer[i]>marsioma[i]){           
              TrendUp = true;
              break;
            }  
            if(/*RSIBuffer[i+1]>=marsioma[i+1]&&/**/RSIBuffer[i]<marsioma[i]) {
              TrendDn = true;     
              break;
            }
        }
/*        
        //if (Buf1UpHigh[i] != 0 && Buf1UpHigh[i] != EMPTY_VALUE)
        if (marsiomaXupSig[i] != 0 && marsiomaXupSig[i] != EMPTY_VALUE){
          TrendUp = true;
          break;
        }
        else
        //if (Buf1DnHigh[i] != 0 && Buf1DnHigh[i] != EMPTY_VALUE){
        if (marsiomaXdnSig[i] != 0 && marsiomaXdnSig[i] != EMPTY_VALUE){
          TrendDn = true;
          break;
        }/**/
      }
      
      for(i=limit;i>=0;i--)
      {  Buffer20[i] = Level1;//20;
	      Buffer50[i] = Level2;//50;
	      Buffer80[i] = Level3;//80
            bup[i] = EMPTY_VALUE; bdn[i] = EMPTY_VALUE;
            sup[i] = EMPTY_VALUE; sdn[i] = EMPTY_VALUE;
            
               if(RSIBuffer[i] > 50)               bup[i] =   6;
               if(RSIBuffer[i] < 50)               bdn[i] =  -6;      
               if(RSIBuffer[i] > MainTrendLong)    bup[i] =  12;
               if(RSIBuffer[i] < MainTrendShort)   bdn[i] = -12;
            
               if(RSIBuffer[i]<20 && RSIBuffer[i]>RSIBuffer[i+1])                sup[i] =  -3;
               if(RSIBuffer[i]>80 && RSIBuffer[i]<RSIBuffer[i+1])                sdn[i] =   4;
               if(RSIBuffer[i]>20 && RSIBuffer[i+1]<=20)                         sup[i] =   5;
               if(RSIBuffer[i+1]>=80 && RSIBuffer[i]<80)                         sdn[i] =  -5;
               if(RSIBuffer[i+1]<=MainTrendShort && RSIBuffer[i]>MainTrendShort) sup[i] =  12;  
               if(RSIBuffer[i]<MainTrendLong && RSIBuffer[i+1]>=MainTrendLong)   sdn[i] = -12;

            marsiomaXupSig[i] = EMPTY_VALUE;
            marsiomaXdnSig[i] = EMPTY_VALUE;
            
            if(RSIBuffer[i+1]<=marsioma[i+1]&&RSIBuffer[i]>marsioma[i]){
              //if (ShowTrendLines)
                marsiomaXupSig[i] = 100; 
            }
            if (RSIBuffer[i]>marsioma[i]){    
              TrendUp = true;
              TrendDn = false;                
            }  
            if(RSIBuffer[i+1]>=marsioma[i+1]&&RSIBuffer[i]<marsioma[i]) {
              //if (ShowTrendLines)
                marsiomaXdnSig[i] = 100;
            }
            if (RSIBuffer[i]<marsioma[i]) {
              TrendUp = false;
              TrendDn = true;     
            }
            /*if (!TrendDn && !TrendUp){ //czemu ???
              TrendDn = false; //na razie
            }/**/
            
      if (RectsBelow)
        double RectVal = -15; 
      else
        RectVal = 115;        
      Buf1DnLow[i] = EMPTY_VALUE;      
      Buf1UpLow[i] = EMPTY_VALUE;
      Buf1UpHigh[i] = EMPTY_VALUE;
      Buf1DnHigh[i] = EMPTY_VALUE;
      Buf1Zero[i] = EMPTY_VALUE;
      if (RectsTrendLines){
        if (TrendUp)
          Buf1UpHigh[i] = RectVal;
        else
        if (TrendDn)
          Buf1DnHigh[i] = RectVal;
      }
      else{        
        if (MathAbs(RSIBuffer[i] - 50) < ZeroLevel){
          if (RSIBuffer[i] > 50){
            Buf1UpLow[i] = RectVal;
            Buf1DnLow[i] = EMPTY_VALUE;
          }  
          else{
            Buf1DnLow[i] = RectVal;      
            
          }  
        }
        else
        if (RSIBuffer[i] > 50 + ZeroLevel)
          Buf1UpHigh[i] = RectVal;
        else  
        if (RSIBuffer[i] < 50 - ZeroLevel)
          Buf1DnHigh[i] = RectVal;
        else  
          Buf1Zero[i] = RectVal;
      }
#ifdef set_global
    if (i < GlobalVarBack){
      string S = GlobalRSIOMASlope +  GlobalVarSuffix + "_" + (string)i;
      if (!SetGlobalVar(S, RSIBuffer[i]))
        Print("RSIOMA Error setting global value");   
      if (FIsNewBar && i == 1)  
         SetGlobalVar("T0_Rsio" + GlobalVarSuffix, Time[0]);     
        
      if (RectsTrendLines){     
         double TrendR = 0;
         if (Buf1UpHigh[i] == RectVal)
           TrendR = 1;
         else
         if (Buf1DnHigh[i] == RectVal)
           TrendR = -1;
           
         S = GlobalRSIOMATrend + GlobalVarSuffix + "_" + (string)i;
         if (!SetGlobalVar(S, TrendR))
           Print("RSIOMA Error setting global value");  
      }
       
    }
#endif 
    if (i == 0){
      //double GUIScale = GetGlobalVar("GUIScale");
      ObjectSetText(LblDY, NormalizeDouble(RSIBuffer[1], 0) + "  " + NormalizeDouble(RSIBuffer[0], 0), DYLabelSize, "Arial", DYLabelColor);/**/   
      double MinChange = 0.1;
      double dY = RSIBuffer[0] - RSIBuffer[1];
      if (MathAbs(dY - LastdY) >= MinChange){
       //string ID = LblDY + "Rect" + IndiUID;//Indicator_Name + Objs;  
       if (LastdY != 0)
         if (dY > LastdY){           
           ObjectSetText(LblDYRect,  CharToStr(110), RectSize, "Wingdings", clrGreen);/**/    
           SetLabelPos(false);
         }     
         else
         if (dY < LastdY){
           ObjectSetText(LblDYRect,  CharToStr(110), RectSize, "Wingdings", clrMaroon);/**/    
           SetLabelPos(false);
         }
       LastdY = dY;
     } 
      //ObjectSet(LblDY, OBJPROP_XDISTANCE, GetX(DYLabelX, GUIScale));
      //ObjectSet(LblDY, OBJPROP_YDISTANCE, GetY(DYLabelY, GUIScale));      
    }
  
                 
   }

#ifdef set_global   
   
   if (!RectsTrendLines)
   /*{     
     if (Buf1UpHigh[0] == RectVal)
       TrendR = 1;
     else
     if (Buf1DnHigh[0] == RectVal)
       TrendR = -1;
   }
   else/**/{
     TrendR = 0;
     for(i=0;i<Last_Bars;i++){
       if (marsiomaXupSig[i] != EMPTY_VALUE){
         TrendR = 1;
         break;
       }
       if (marsiomaXdnSig[i] != EMPTY_VALUE){
         TrendR = -1;
         break;
       }
     }
     S = GlobalRSIOMATrend + GlobalVarSuffix;
     if (!SetGlobalVar(S, TrendR))
       Print("RSIOMA Error setting global value");
   }
  
#endif 
   //
   //
   //
   //
   //
   
  // for (i=0;i<indicator_buffers;i++) SetIndexDrawBegin(i,Bars-Last_Bars);
   FIsNewBar = false;
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void drawLine(double lvl,string name, color Col )
{  return;
   ObjectDelete(name);
   ObjectCreate(name, OBJ_HLINE, WindowFind(short_name), Time[0], lvl,Time[0], lvl);
   ObjectSet(name   , OBJPROP_STYLE, STYLE_DOT);
   ObjectSet(name   , OBJPROP_COLOR, Col);        
   ObjectSet(name   , OBJPROP_WIDTH, 1);
}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringUpperCase(tfs);
       
         if (tfs=="M1" ||tfs=="1")       tf=PERIOD_M1;
         if (tfs=="M5" ||tfs=="5")       tf=PERIOD_M5;
         if (tfs=="M15"||tfs=="15")      tf=PERIOD_M15;
         if (tfs=="M30"||tfs=="30")      tf=PERIOD_M30;
         if (tfs=="H1" ||tfs=="60")      tf=PERIOD_H1;
         if (tfs=="H4" ||tfs=="240")     tf=PERIOD_H4;
         if (tfs=="D1" ||tfs=="1440")    tf=PERIOD_D1;
         if (tfs=="W1" ||tfs=="10080")   tf=PERIOD_W1;
         if (tfs=="MN" ||tfs=="43200")   tf=PERIOD_MN1;
         
   return(tf);
}
string TimeFrameToString(int tf)
   {
   string tfs="0";
   switch(tf) {
      case PERIOD_M1:  tfs="Period M1"  ; break;
      case PERIOD_M5:  tfs="Period M5"  ; break;
      case PERIOD_M15: tfs="Period M15" ; break;
      case PERIOD_M30: tfs="Period M30" ; break;
      case PERIOD_H1:  tfs="Period H1"  ; break;
      case PERIOD_H4:  tfs="Period H4"  ; break;
      case PERIOD_D1:  tfs="Period D1"  ; break;
      case PERIOD_W1:  tfs="Period W1"  ; break;
      case PERIOD_MN1: tfs="Period MN1";
      }
   return(tfs);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      Char;
   
   while(lenght >= 0)
      {
         Char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((Char > 96 && Char < 123) || (Char > 223 && Char < 256))
                  s = StringSetChar(s, lenght, Char - 32);
          else 
              if(Char > -33 && Char < 0)
                  s = StringSetChar(s, lenght, Char + 224);
                  
         //
         //
         //
         //
         //
                                 
         lenght--;
      }
   
   //
   //
   //
   //
   //
   
   return(s);
}


datetime isNewBarT0 = 0; 
bool FIsNewBar = true; 
bool isNewBar(){
/*
  for (int i = MathMin(Bars, Last_Bars) - 1; i > 1; i--){
    arrUSD[i] = arrUSD[i - 1];
  }
  SinLoop++;
  arrUSD[0] = 0.1 * MathSin(M_PI * SinLoop/20);
  return(true);
/**/  
//<<<<<<<<<<<
  datetime T = iTime(NULL, 0 , 0);
  if (isNewBarT0 < T){
    isNewBarT0 = T;//iTime(NULL , 0 , 0);
    return (true); 
  } 
  else{
    return (false);
  }
}